// 跳转页面方法
function showpage(x, y) {
  mui.openWindow({
    url: x,
    id: y,
    preload: true,
    show: {
      aniShow: 'pop-in'
    },
    styles: {
      popGesture: 'hide'
    },
    waiting: {
      autoShow: true
    }
  });
}

/**
 * 作用:做所有密码校验
 */
function checkAllPwd() {

  var OldPass = $('#oldpwd').val();
  var newPwd = $('#newpwd').val();

  // 密码验证
  var reg = /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8,16}$/; //声明正则表达式，密码必须由数字和字母组成

  // 旧密码不能为空
  if(OldPass == "") {

    mui.toast('旧密码不能为空');
    return false;
  }

  // 验证新密码是否为空
  if(newPwd == "") {

    mui.toast('新密码不能为空');
    return false;

  } else {

    var numAll = /^[0-9]*$/; //纯数字验证
    var zimuAll = /^[a-zA-Z]*$/; //纯字母验证

    newPwd = newPwd.trim(); //去掉空格

    if(newPwd.length < 8 || newPwd.length > 16) {
      mui.toast('新密码必须为8~16个字符');
      return false;
    }
    if(numAll.test(newPwd)) {
      mui.toast('密码不能是纯数字');
      return false;
    }
    if(zimuAll.test(newPwd)) {
      mui.toast('密码不能是纯字母');
      return false;
    }
    // 验证密码是否符合正则
    if(!reg.test(newPwd)) {
      mui.toast('密码必须为8-16位：由字母或数字组成');
      return false;
    }

  }

  return true;
}

/**
 * 修改密码
 */
mui("body").on("tap", "#subbtn", function() {

  //开始传值请求
  var guid = window.localStorage.getItem('HEART_APP_LOGINID');
  var OldPass = $('#oldpwd').val();
  var newPwd = $('#newpwd').val();

  var allPwd = checkAllPwd();

  /**
   * 服务器地址：https://gz.fromfuture.cn/chis
   * 中间件名：GzyyInterface02
   * 方法名：update
   * 参数
   * @param guid
   * @param OldPass
   * @param NewPass
   */
  var url = HEART_WEBBASE + "Upass/Upda?id=" + guid + "&oldPass=" + OldPass + "&newPass=" + newPwd;
//console.log(url);

  if(allPwd == true) {

    try {

      $.ajax({
        url: url,
        async: false,
        timeout: 8000,
        type: 'POST',
        dataType: "json",
        success: function(result) {

          try {

            if(result.code == "000") {
              mui.toast('修改成功');
              localStorage.clear(); // 清空localStorage数据

              //跳转到登录界面	
              setTimeout(function() {
                showpage("login.html", "login");
              }, 2000);

							if(HEART_BROWSETYPE == 'IOS') {
								console.log('IOS跳转');
							}
              if(HEART_BROWSETYPE == 'ANDROID') {
              	console.log('ANDROID跳转');
                try {
                  window.android.changePwdSuccessToLogin();
                } catch(e) {
                  console.log('修改密码成功后跳转到登录界面：' + e);
                }

              } else {

              }

            } else {

              mui.toast("请检查是否输入正确"); //提示后台返回的结果

            }

          } catch(e) {

            mui.toast('请检查网络连接');

          }

        },
        error: function(xhr, status, error) {

          if(status == "error")
            mui.toast('请检查网络连接');

        }

      });

    } catch(e) {

      mui.toast("请检查网络连接");
    }

  }

})