
$(function () {    
    (function ($) {
        $.fn.jalendar = function (options) {
            
            var settings = $.extend({
                customDay: new Date(),
                color: '#65c2c0',
                lang: 'EN'
            }, options);
            
            // Languages            
            var dayNames = {},
            monthNames = {},
            lEvent = {};
            
//			dayNames['CN'] = new Array('周日','周一', '周二', '周三', '周四', '周五', '周六');
			dayNames['CN'] = new Array('周一', '周二', '周三', '周四', '周五', '周六','周日');
            monthNames['CN'] = new Array('1月', '2月', '3月', '4月', '5月', '6月','7月','8月','9月','10月','11月','12月');
            lEvent['CN'] = '暂无信息';
            
            var $this = $(this);
            var div = function (e, classN) {
                return $(document.createElement(e)).addClass(classN);
            };
            
            var clockHour = [],clockMin = [];
            for (var i=0;i<24;i++ ){clockHour.push(div('div', 'option').text(i))}
            for (var i=0;i<59;i+=5 ){clockMin.push(div('div', 'option').text(i))}
                
            // 动态插入html结构
            $this.append(
                div('div', 'wood-bottom'),
                div('div', 'jalendar-pages').append(
                    div('div', 'header').css('background-color', '#EBF2FA').append(
                        div('a', 'prv-m'),
                        div('h1'),
                        div('a', 'nxt-m'),
                        div('div', 'day-names')
                    ),
                    div('div', 'days')
                ),
                div('div', 'events').append(
                    div('div', 'eventsInfo'),
                    div('div', 'events-list')
                )
            );
            
            // Adding day (1-28、1-29、1-30、1-31)
            for (var i = 0; i < 42; i++) {
                $this.find('.days').append(div('div', 'day'));
            }
            
            // Adding day (周日-周一)
            for (var i = 0; i < 7; i++) {
                $this.find('.day-names').append(div('h2').text(dayNames[settings.lang][i]));
            }

            var d = new Date(settings.customDay),//中国标准时间
            year = d.getFullYear(),//年
            date = d.getDate(),//日
            month = d.getMonth();//月
//          if(month <= 9){month = '0'+month;}
//          if(date <= 9){date = '0'+date;}
            
            var isLeapYear = function(year1) {
                var f = new Date();
                f.setYear(year1);
                f.setMonth(1);
                f.setDate(29);
                return f.getDate() == 29;
            };
        	
        	//取当天
            var feb,
            febCalc = function(feb) {
                if (isLeapYear(year) === true) { feb = 29; } else { feb = 28; } 
                return feb;
            },
            monthDays = new Array(31, febCalc(feb), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

            function calcMonth() {

                monthDays[1] = febCalc(feb);//当天

                var weekStart = new Date();//中国标准时间
                weekStart.setFullYear(year, month, 0);//将标准时间设置为年月日
                var startDay = weekStart.getDay();  
                $this.find('.header h1').html(year+'年'+monthNames[settings.lang][month]);//当前年月
        
                $this.find('.day').html('&nbsp;');//日期空格
                $this.find('.day').removeClass('this-month');
                for (var i = 1; i <= monthDays[month]; i++) {
                    startDay++;
                    var months = month+1,dates = i;
                    
                    if(months <= 9){months = '0'+months;}else{months = month+1;}//if月份 < 9则+0
                    if(dates <= 9){dates = '0'+dates;}else{dates = i;}//if日期 < 9则+0

					$this.find('.day').eq(startDay-1).addClass('this-month').attr('data-date', year+'-'+months+'-'+dates).html(i);//添加每月日期天数
                }
                
                if (month == d.getMonth()) {

                    $this.find('.day.this-month').removeClass('today').eq(date-1).addClass('today').css({'color':'#2C8EFF'});//当前日期
                } else {
                    $this.find('.day.this-month').removeClass('today').removeClass('currentDate');
                }
                
                // added event
                $this.find('.added-event').each(function(i){
                    $(this).attr('data-id', i);

                    $this.find('.this-month[data-date="' + $(this).attr('data-date') + '"]').append(
                        div('div','event-single').attr('data-id', i).append(
                        	
                            div('div','details').append(
                                div('div', 'clock').append($(this).find('span'))
                            )
                        )
                    );
                });
                
				$this.find('.day').removeClass('have_current');//清空样式
				$this.find('.day').has('.event-single').addClass('have_current');//有数据突出显示
                calcTotalDayAgain();
            }
            
            calcMonth();
            
            var arrows = new Array ($this.find('.prv-m'), $this.find('.nxt-m'));
            var dropdown = new Array ($this.find('.add-time .select span'), $this.find('.add-time .select .dropdown .option'), $this.find('.add-time .select'));
            var allDay = new Array ('.all-day fieldset[data-type="disabled"]', '.all-day fieldset[data-type="enabled"]');
            $this.find('.events').css('height', ($this.height()-197) );
            $this.find('.select .dropdown .option').hover(function() {
                $(this).css('background-color', settings.color); 
            }, function(){
                $(this).css('background-color', 'inherit'); 
            });

            // calculate for scroll
            function calcScroll() {
                if ( $this.find('.events-list').height() < $this.find('.events').height() ) { $this.find('.events-list').css('border', 'none') } else {}
            }
            
            // Calculate total event again
            function calcTotalDayAgain() {
                var eventCount = $this.find('.this-month .event-single').length;
                $this.find('.events h3 span b').text($this.find('.events .event-single').length)
            }
            
            function prevAddEvent() {
                $this.find('.day').removeClass('selected').removeAttr('style');
                
                $this.find('.today').css('color', '#2C8EFF');
            }
            
		
			/*
			 * ajax请求封装
			 */
			var arry = {};
			function _ajax(url,data,callback){
				
				try {
				  	$.ajax({
					    url:url,
						type:"GET",
						data:data,
						async: false,
						success: function(data) {
					  		try {
					  			
					  			try {
						  			data = data.trim();
					  				data = JSON.parse(data)
						  			arry = data.data.list;
								  	if(data.code == '000'){
								  		
								  		if(arry == ''){
								  			mui.toast('当月无排班信息');
								  			
								  		}else{
								  			
								  			$('#myId3').find('.added-event').remove();
								  			for (var i = 0; i < arry.length; i ++) {
												
												var doctorformlist = arry[i].doctorformlist,
												spanHtml = '';
												if(doctorformlist != '' && doctorformlist.length > 0){
											
													for(var j = 0 ; j < doctorformlist.length; j ++){
		
														if(doctorformlist[j].formstate == 0){
															spanHtml += '<span style="display:none"><i name="'+doctorformlist[j].id+'">'+doctorformlist[j].formtimes+'</i>'+'&nbsp;&nbsp;&nbsp;'+'未预约'+'<button type="button" class="mui-btn mui-btn-blue mui-btn-outlined">停诊</button></span>';
														}else{
															spanHtml += '<span style="display:none"><i name="'+doctorformlist[j].id+'">'+doctorformlist[j].formtimes+'</i>'+'&nbsp;&nbsp;&nbsp;'+'已预约'+'</span>';
														}
													}
												}
												var dates = '<div class="added-event" data-date="'+arry[i].formdate+'" data-time="'+arry[i].formdate+'">'+spanHtml+'</div>';
												$('#myId3').append(dates);
											}
								  		}
								  		
									}else{
										mui.toast('修改失败');
									}
									
						  		} catch(e) {
							    
							    	mui.toast('获取数据失败');
						  		}

								
					  		} catch(e) {
						    
						    	mui.toast('获取数据失败');
					  		}
						},
						error: function(xhr, textStatus, error) {						
							if(textStatus == "error")
							mui.toast('请检查网络连接');
						}
			  		});
				
				} catch(e) {
				
				  mui.toast("请检查网络连接");
				
			    }
			}
			
			
			/*
			 * 定义全局变量
			 */
			var mons = 1,months,mydates,nowMonth = month+1,
			nowDates = year+'-'+nowMonth,//当前日期
		 	todayContent = $('.today').find('.event-single').html();//今天状况
		 	if(todayContent == null){todayContent = '<span>暂无信息</span>'}else{todayContent = todayContent}
		 	var webUrl = HEART_WEBBASE+"Dform/select?docid="+HEART_APP_DOCID,
            nowDatetime = $('.today').attr('data-date'),//当前日期
			nowWeeks = getMyDay(new Date($('.today').attr('data-date'))),//当前周几
			dateWeeks = '<span>'+nowDatetime+'<br>'+nowWeeks+'</span><a href="#forward">编辑排班</a><br><b><img src="./images/gt.png" />停诊需提前24小时，一个月内可以停诊2次</b>';
            
            /*
			 * 右键
			 */
            arrows[1].on('click', function () {
            	
                if ( month >= 11 ) {//大于11月份
                    month = 0;//如果月份大于12个月初始化
                    year++;//如果月份大于12个月初始化，年份在原来基础上+1
                    months = month+mons;   mydates = year+'-'+months;
                    
                    //判断是否为当前月
                    if(mydates != nowDates){
                    	
                    	//if 不是当前月份，清空预约列表，隐藏日期周几
						$('.events-list').html(''),$('.eventsInfo span').hide(),$('.eventsInfo b').hide();
						
                	}else{
						//if 是当前月份，恢复预约列表，显示日期周几
                    	$('.events-list').html(todayContent),$('.eventsInfo').html(dateWeeks);
                	}
                    
                    //给日期加0
					if(months < 10){months = "0"+months;}else{months = months;}//加0
                    mydates = year+'-'+months;
                    _ajax(webUrl,{
						formdate:mydates//状态
					});
					$('.eventsInfo').attr('name',mydates)
					
                } else {//小于11月份
                    month++;   months = month+mons;   mydates = year+'-'+months;
                    
                    //判断是否为当前月
                    if(mydates != nowDates){
                    	
						//if 不是当前月份，清空预约列表，隐藏日期周几
						$('.events-list').html(''),$('.eventsInfo span').hide(),$('.eventsInfo b').hide();
						
                	}else{
                		//if 是当前月份，恢复预约列表，显示日期周几
                		$('.events-list').html(todayContent),$('.eventsInfo').html(dateWeeks);
                	}
 
                    if(months < 10){months = "0"+months;}else{months = months;}//加0
                    mydates = year+'-'+months;
                    _ajax(webUrl,{
						formdate:mydates//状态
					});
					$('.eventsInfo').attr('name',mydates)

                }
                calcMonth();
                prevAddEvent();
            });
            
            
            /*
			 * 左键
			 */
            arrows[0].on('click', function () {
                dayClick = $this.find('.this-month');
                if ( month === 0 ) {
                    month = 11;   year--;   months = month+mons;   mydates = year+'-'+months;
                    
                    //判断是否为当前月
                    if(mydates == nowDates){
                    	//if 是当前月份，恢复预约列表，显示日期周几
                		$('.events-list').html(todayContent),$('.eventsInfo').html(dateWeeks);
                		
                	}else{
                		//if 不是当前月份，清空预约列表，隐藏日期周几
						$('.events-list').html(''),$('.eventsInfo span').hide(),$('.eventsInfo b').hide();
                	}
                    
                    if(months < 10){months = "0"+months;}else{months = months;}//加0
                    mydates = year+'-'+months;
                    _ajax(webUrl,{
						formdate:mydates//状态
					});
					$('.eventsInfo').attr('name',mydates)
					
                } else {
                	
                    month--;   months = month+mons;   mydates = year+'-'+months;
                    
                    //判断是否为当前月
                    if(mydates == nowDates){
                    	//if 是当前月份，恢复预约列表，显示日期周几
                		$('.events-list').html(todayContent),$('.eventsInfo').html(dateWeeks);
                		
                	}else{
                		//if 不是当前月份，清空预约列表，隐藏日期周几
						$('.events-list').html(''),$('.eventsInfo span').hide(),$('.eventsInfo b').hide();
                	}
                   
                    if(months < 10){months = "0"+months;}else{months = months;}//加0
                    mydates = year+'-'+months;
                    _ajax(webUrl,{
						formdate:mydates//状态
					});
					$('.eventsInfo').attr('name',mydates)
                   
                }
                calcMonth();
                prevAddEvent();
            });
            
            
            /*
			 * 点击日期触发
			 */
            $this.on('click', '.this-month', function () {

                var eventSingle = $(this).find('.event-single');
				var nowDates = $(this).attr('data-date');//当天日期
				var nowWeeks = getMyDay(new Date($(this).attr('data-date')));//当天周几

                prevAddEvent();//切换
                $(this).addClass('selected').css({'background-color': '#2C8EFF','color':'#fff'});//选中样式更换
                	
            	if(eventSingle.clone().length <= 0){
            		
            		$this.find('.eventsInfo').html('<span>'+nowDates+'<br />'+nowWeeks+'</span><a href="#forward">编辑排班</a><br><b><img src="./images/gt.png" />停诊需提前24小时，一个月内可以停诊2次</b>');
            		$this.find('.events-list').html('<span>暂无信息</span>')
            	}else{
            		
            		$this.find('.eventsInfo').html('<span>'+nowDates+'<br />'+nowWeeks+'</span><a href="#forward">编辑排班</a><br><b><img src="./images/gt.png" />停诊需提前24小时，一个月内可以停诊2次</b>');
            		$this.find('.events-list').html(eventSingle.clone())
            	}
            	
            	/*
				 * 查询当前日期排班
				 */
           		try {
				  	$.ajax({
					    url:HEART_WEBBASE+"v2/admin/queryFormTime?docid="+HEART_APP_DOCID+"&date="+nowDates,
						type:"GET",
						success: function(data) {
							
							data = data.trim();
							data = JSON.parse(data);
							
					  		if(data.code == 000){
								
								arry = data.date;
								$('.clock').html('');
									
								var spanHtml = '';
					  			for (var i = 0; i < arry.length; i ++) {
									
									//if formstate为0 则视为未预约
									if(arry[i].formstate == 0){
										
										/*
										 * 时间段转换为时间戳
										 */
									   	startTime = new Date(Date.parse((nowDates+' '+arry[i].time.substr(0,5)).replace(/-/g, "/"))).getTime(),//排班开始时间戳
									   	endTime = new Date(Date.parse((nowDates+' '+arry[i].time.substr(6,5)).replace(/-/g, "/"))).getTime();//排班结束时间戳
								        
								 
										//if 当前时间  > 日期时间，则不现实按钮
										if (currentTime > startTime) {
											
							            	spanHtml = 
												'<span style="display:none">'+
													'<i name="'+arry[i].id+'">'+arry[i].time+'</i>'+
													'<b>未预约</b>'+'<button type="button" id="'+arry[i].formstate+'" class="mui-btn mui-btn-outlined disableBtn" style="color:#999">停诊</button>'+
												'</span>';
								        } 
								        else {

											spanHtml = 
											'<span style="display:none">'+
												'<i name="'+arry[i].id+'">'+arry[i].time+'</i>'+
												'<b>未预约</b>'+'<button type="button" id="'+arry[i].formstate+'" class="mui-btn mui-btn-blue mui-btn-outlined">停诊</button>'+
											'</span>';
								        }
										        
									}else if(arry[i].formstate == 2){
										spanHtml = '<span style="display:none;"><i name="'+arry[i].id+'">'+arry[i].time+'</i>'+'<b style="color:red;">已停诊</b>'+'</span>';
									}else{
										spanHtml = '<span style="display:none"><i name="'+arry[i].id+'">'+arry[i].time+'</i>'+'<b>已预约</b>'+'</span>';
									}

								$('.clock').append(spanHtml);
	
								}
						  		
					  		}else{
					  			mui.toast('请检查网络连接');
					  		}
						},
						error: function(xhr, textStatus, error) {						
							if(textStatus == "error")
							mui.toast('请检查网络连接');
						}
			  		});
				
				} catch(e) {
				
				  mui.toast("请检查网络连接");
			   	}
				
            });
            
            /*
			 * 默认显示当前日期排班状态
			 */
            var eventSingle = $(this).find('.event-single')
            	months = month+mons;
        	if(months <= 9){months = '0'+months;}
   		 	if(date <= 9){date = '0'+date;}
            var nowDate = year+'-'+months+'-'+date,//当前日期
            todays = $('.today').attr('data-date'),//
			yuyueTime = $('.today').find('.clock').html();
			
            if(todays == nowDate){
            	
            	$this.find('.eventsInfo').html('<span>'+todays+'<br />'+getMyDay(new Date(todays))+'</span><a href="#forward">编辑排班</a><br><b><img src="./images/gt.png" />停诊需提前24小时，一个月内可以停诊2次</b>');
				$this.find('.eventsInfo').attr('name',year+'-'+months)

				$('.events-list').append(yuyueTime);
				
				if($('.today').find('.event-single').text() == ''){
                	$('.events-list').html('<span>暂无信息</span>');
                }
            }else{
            	$('.events-list').html('<span>暂无信息</span>');
            }
            
           	/*
			 * 确定是否停诊
			 */
           	$('.events-list').on('tap', '.mui-btn-blue', function(event) {
           		var thisTable = $(this),
           		thisId = $(this).siblings('i').attr('name'),
           		yearmonth = $('.eventsInfo').attr('name'),//月份
           		
           		elem = this,
				li = elem.parentNode.parentNode,
				
				liContent = $(this).siblings('i').html(),
				webUrl = HEART_WEBBASE+"Dform/update?id="+thisId+"&formdate="+yearmonth+"&docid="+HEART_APP_DOCID;
	
           		/*
				 * 查询停诊次数
				 */
           		try {
				  	$.ajax({
					    url:HEART_WEBBASE+"Dform/querst?docid="+HEART_APP_DOCID+"&formdate="+yearmonth,
						type:"GET",
						success: function(data) {
							
							data = data.trim();
							data = JSON.parse(data);
							
					  		if(data.code == 000){

					  			if(data.data.number < 1){
					  			
					  				mui.confirm('是否取消'+liContent+'此排班？', '提示', btnArray, function(e) {
										if (e.index == 0) {

										} else {
											
											tzAjax(webUrl);
											if(data.code == 000){
												thisTable.hide().siblings('b').html('已停诊').css('color','red');
												thisTable.attr('id',2)
											}
										}
									});
					  				
					  			}else if(data.data.number == 1){
					  				
					  				mui.confirm('您已有1次停诊操作，还剩1次，是否确认对'+liContent+'次时间段停诊？', '提示', btnArray, function(e) {
										if (e.index == 0) {
//											alert('否')
										} else {
											
											tzAjax(webUrl);
											if(data.code == 000){
												thisTable.hide().siblings('b').html('已停诊').css('color','red');
											}
										}
									});
								
					  			}else{
					  				
					  				mui.toast('您已有2次停诊操作，不能再进行此功能操作');
					  			}
					  			
					  		}else{
					  			mui.toast('请检查网络连接');
					  		}
						},
						error: function(xhr, textStatus, error) {						
							if(textStatus == "error")
							mui.toast('请检查网络连接');
						}
			  		});
				
				} catch(e) {
				
				  mui.toast("请检查网络连接");
			   	}
				
			});
			var btnArray = ['否', '是'];
        };

    }(jQuery));
});


function tzAjax(url,data,callback){
	try {
	  	$.ajax({
		    url:url,
			type:"POST",
			success: function(data) {
		  		try {
		  			data = data.trim();
	  				data = JSON.parse(data)
		  			arry = data.data.list;
				  	if(data.code == '000'){
				  		
				  		if(data.data == 'success'){
//				  			mui.toast('修改成功');
				  			
				  		}else if(data.data == '停诊需提前24小时！'){
				  			
				  			mui.toast('停诊需提前24小时');
				  		}else{
				  			
				  			mui.toast('每月停诊次数不得超过两次!');
				  		}
					}else{
						mui.toast('修改失败');
					}
					
		  		} catch(e) {
			    	mui.toast('获取数据失败');
		  		}
			},
			error: function(xhr, textStatus, error) {						
				if(textStatus == "error")
				mui.toast('请检查网络连接');
			}
  		});
	
	} catch(e) {
	
	  mui.toast("请检查网络连接");
   	}
}





